/*
 *      preferences.h
 *      
 *      Copyright 2008 Tuxgasy <tuxgasy@tuxfamily.org>
 *      
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 2 of the License, or
 *      (at your option) any later version.
 *      
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *      
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef DEF_PREFERENCES
#define DEF_PREFERENCES

typedef struct Preferences Preferences;
struct Preferences{
  glda *pGlda;
  
  gboolean isNeedReboot;
  gboolean isNeedReloadList;
  
  GtkWidget *pEntryListProducts;
  
  GtkWidget *pEntryCategory;
  GtkWidget *pEntrySubCategory;
  GtkWidget *pEntryProductName;
  GtkWidget *pEntryProductPrice;
  GtkWidget *pComboBoxCategoryInSubCategory;
  GtkWidget *pComboBoxCategoryInProduct;
  GtkWidget *pComboBoxSubCategoryInProduct;
  
  GtkTreeStore *pTreeListProducts;
  GtkTreeSelection *selectListProducts;
};

enum {COLUMN_PRODUCTS_PREFERENCES, COLUMN_PRICE_PREFERENCES,
			COLUMN_REFCATEGORY, COLUMN_REFSUBCATEGORY, COLUMN_REFPRODUCTS,
			N_COLUMN_PRODUCTS_PREFERENCES};

/********************************** Interface **********************************/
void create_pPreferences(glda *pGlda);

GtkWidget *create_pGeneral(Preferences *pPreferencesData);

GtkWidget *create_pPrintPreferences(Preferences *pPreferencesData);

void createFontSelectionDialog(Preferences *pPreferencesData);

void createColorSelectionDialog(Preferences *pPreferencesData);

GtkWidget *create_pListProducts(Preferences *pPreferencesData);

GtkWidget *create_EditListProducts(Preferences *pPreferencesData);

void createListProducts(Preferences *pPreferencesData);

GtkWidget *createComboBoxCategory(Preferences *pPreferencesData);

GtkWidget *createComboBoxSubCategory(Preferences *pPreferencesData, gint positionCategory);

void changeComboBoxSubCategory(Preferences *pPreferencesData, gint positionCategory);

void removeFromList(Preferences *pPreferencesData);

void removeCategoryFromInterface(Preferences *pPreferencesData, gchar *pRef);

void removeSubCategoryFromInterface(Preferences *pPreferencesData, gchar *pRefCategory, gchar *pRef);

void editList(Preferences *pPreferencesData);

/********************************** Callbacks **********************************/

/*** callback for notebook "General" ***/
void OnChangedDevise(GtkWidget *pEntry, Preferences *pPreferencesData);

void OnClickedShowColumnPriceProduct(GtkWidget *pCheckButton, Preferences *pPreferencesData);

void OnClickedShowColumnQuantityProduct(GtkWidget *pCheckButton, Preferences *pPreferencesData);

void OnClickedShowTotalQuantityProduct(GtkWidget *pCheckButton, Preferences *pPreferencesData);

void OnClickedShowTotalPriceProduct(GtkWidget *pCheckButton, Preferences *pPreferencesData);

/*** callback for notebook "print" ***/
void OnSelectFontPrint(GtkWidget *pButton, Preferences *pPreferencesData);

void OnSelectColorPrint(GtkWidget *pButton, Preferences *pPreferencesData);

void OnClickedShowTitlePrint(GtkWidget *pCheckButton, Preferences *pPreferencesData);

void OnClickedShowPagePrint(GtkWidget *pCheckButton, Preferences *pPreferencesData);

void OnValueChangedBorder(GtkWidget *pSpin, Preferences *pPreferencesData);

void OnClickedShowColumnNumberPrint(GtkWidget *pCheckButton, Preferences *pPreferencesData);

void OnClickedShowColumnNamePrint(GtkWidget *pCheckButton, Preferences *pPreferencesData);

void OnClickedShowColumnPricePrint(GtkWidget *pCheckButton, Preferences *pPreferencesData);

void OnClickedShowColumnQuantityPrint(GtkWidget *pCheckButton, Preferences *pPreferencesData);

void OnClickedShowLineTotalPrint(GtkWidget *pCheckButton, Preferences *pPreferencesData);

/*** callback for notebook "List of product" ***/
void OnSelectFileListProducts(GtkWidget *pButton, Preferences *pPreferencesData);

void OnClearCategory(GtkWidget *pButton, Preferences *pPreferencesData);

void OnAddCategory(GtkWidget *pButton, Preferences *pPreferencesData);

void OnClearSubCategory(GtkWidget *pButton, Preferences *pPreferencesData);

void OnAddSubCategory(GtkWidget *pButton, Preferences *pPreferencesData);

void OnClearProduct(GtkWidget *pButton, Preferences *pPreferencesData);

void OnAddProduct(GtkWidget *pButton, Preferences *pPreferencesData);

void OnChangedComboBoxCategory(GtkWidget *pComboBox, Preferences *pPreferencesData);

void OnRemoveFromList(GtkWidget *pButton, Preferences *pPreferencesData);

void OnEditList(GtkWidget *pButton, Preferences *pPreferencesData);

#endif
